package com.donglan.BYWeApp.config;

import com.donglan.BYWeApp.interceptors.AuthInterceptor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

/**
 * @author shj
 * @date 2021/5/31 1:58 下午
 */
@Configuration
public class WebConfigurer implements WebMvcConfigurer {

    @Autowired
    private AuthInterceptor authInterceptor;

    @Override
    public void addInterceptors(InterceptorRegistry registry) {
        InterceptorRegistration interceptorRegistration = registry.addInterceptor(authInterceptor);
        interceptorRegistration.addPathPatterns("/order/**",
                "/admin/**",
                "/user/search/**",
                "/dict/**",
                "/dicttype/**",
                "/activity/**",
                "/reserveOrder/search/**");
        interceptorRegistration.excludePathPatterns("/admin/login","/dict/type/**");
    }
}
