package com.donglan.BYWeApp.controller;

import com.donglan.BYWeApp.common.PageResult;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.entity.Activity;
import com.donglan.BYWeApp.service.ActivityService;
import com.donglan.BYWeApp.validation.ActivityValidationGroup;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * @author shj
 * @date 2021/6/10 2:21 下午
 */
@RestController
@CrossOrigin
@RequestMapping(value = "/activity")
public class ActivityController {

    @Autowired
    private ActivityService activityService;

    @RequestMapping(value = "",method = RequestMethod.POST)
    public Result add(@Validated(value = ActivityValidationGroup.Add.class) @RequestBody Activity activity){
        activity = activityService.add(activity);
        return Result.success("添加成功",activity);
    }

    @RequestMapping(value = "",method = RequestMethod.PUT)
    public Result update(@Validated(value = ActivityValidationGroup.Update.class) @RequestBody Activity activity){
        activity = activityService.update(activity);
        return Result.success("添加成功",activity);
    }

    @RequestMapping(value = "/{activityId}",method = RequestMethod.DELETE)
    public Result add(@PathVariable Long activityId){
        activityService.logicDeleteById(activityId);
        return Result.success("删除成功",null);
    }

    @RequestMapping(value = "/search/{page}/{size}",method = RequestMethod.POST)
    public Result search(@PathVariable Integer page,@PathVariable Integer size,@RequestBody Activity activity){
        Page<Activity> pageInfo = activityService.search(page,size,activity);
        return Result.success("查询成功",new PageResult<>(pageInfo.getTotalElements(),pageInfo.getContent()));
    }
}
