package com.donglan.BYWeApp.controller;

import cn.hutool.core.collection.CollUtil;
import com.donglan.BYWeApp.common.PageResult;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.entity.Admin;
import com.donglan.BYWeApp.entity.User;
import com.donglan.BYWeApp.service.AdminService;
import com.donglan.BYWeApp.validation.AdminValidationGroup;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @author shj
 * @date 2021/5/31 1:09 下午
 */
@RestController
@RequestMapping("/admin")
@CrossOrigin
public class AdminController {

    @Autowired
    private AdminService adminService;


    @RequestMapping(value = "/search/{page}/{size}",method = RequestMethod.POST)
    private Result search(@PathVariable Integer page,@PathVariable Integer size,@RequestBody Admin admin){
        Page<Admin> pageInfo = adminService.search(page,size,admin);
        return Result.success("查询成功",new PageResult<>(pageInfo.getTotalElements(),pageInfo.getContent()));

    }

    @RequestMapping(value = "",method = RequestMethod.POST)
    public Result add(@Validated(AdminValidationGroup.Add.class) @RequestBody Admin admin){
        admin = adminService.add(admin);
        admin.setPassword("");
        return Result.success("添加成功",admin);
    }

    @RequestMapping(value = "/{adminId}",method = RequestMethod.DELETE)
    public Result remove(@PathVariable Long adminId ){
        adminService.logicDeleteById(adminId);
        return Result.success("删除成功",null);
    }


    @RequestMapping(value = "/login",method = RequestMethod.POST)
    public Result login(@RequestBody Admin admin){
        String token = adminService.login(admin);
        Map<String,String> map = CollUtil.newHashMap();
        map.put("token",token);
        return Result.success("登录成功",map);
    }
}
