package com.donglan.BYWeApp.controller;

import com.donglan.BYWeApp.common.PageResult;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.entity.Dict;
import com.donglan.BYWeApp.service.DictService;
import com.donglan.BYWeApp.validation.DictValidationGroup;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author shj
 * @date 2021/6/9 9:28 上午
 */
@RestController
@CrossOrigin
@RequestMapping(value = "/dict")
public class DictController {
    @Autowired
    private DictService dictService;

    @RequestMapping(value = "/{id}",method = RequestMethod.GET)
    public Result findById(@PathVariable Long id){
        return  Result.success("查询成功",dictService.findById(id));
    }

    @RequestMapping(value = "",method = RequestMethod.POST)
    public Result add(@Validated(value = DictValidationGroup.Add.class) @RequestBody Dict dict){
        dict = dictService.add(dict);
        return  Result.success("查询成功",dict);
    }

    @RequestMapping(value = "",method = RequestMethod.PUT)
    public Result update(@Validated(value = DictValidationGroup.Update.class) @RequestBody Dict dict){
        dict = dictService.update(dict);
        return  Result.success("修改成功",dict);
    }

    @RequestMapping(value = "/{id}",method = RequestMethod.DELETE)
    public Result deleteById(@PathVariable Long id){
        dictService.deleteById(id);
        return  Result.success("删除成功",null);
    }


    @RequestMapping(value = "/type/{dataType}",method = RequestMethod.GET)
    public Result find(@PathVariable String dataType){
        List<Dict> list = dictService.findByType(dataType);
        return Result.success("查询成功",list);
    }

    @RequestMapping(value = "/search/{page}/{size}",method = RequestMethod.POST)
    public Result deleteById(@PathVariable Integer page,@PathVariable Integer size,@RequestBody Dict dict){
        Page<Dict> pageinfo = dictService.search(page, size, dict);
        return  Result.success("查询成功",new PageResult<>(pageinfo.getTotalElements(),pageinfo.getContent()));
    }
}
