package com.donglan.BYWeApp.controller;

import com.donglan.BYWeApp.common.PageResult;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.entity.Dict;
import com.donglan.BYWeApp.entity.DictType;
import com.donglan.BYWeApp.service.DictService;
import com.donglan.BYWeApp.service.DictTypeService;
import com.donglan.BYWeApp.validation.DictTypeValidationGroup;
import org.omg.CORBA.PUBLIC_MEMBER;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author shj
 * @date 2021/6/9 9:33 上午
 */
@RestController
@RequestMapping(value = "/dicttype")
@CrossOrigin
public class DictTypeController {

    @Autowired
    private DictTypeService dictTypeService;


    @RequestMapping(value = "",method = RequestMethod.POST)
    public Result add(@Validated(value = DictTypeValidationGroup.Add.class) @RequestBody DictType dictType){
        dictType = dictTypeService.add(dictType);
        return  Result.success("新增成功",dictType);
    }

    @RequestMapping(value = "",method = RequestMethod.PUT)
    public Result update(@Validated(value = DictTypeValidationGroup.Update.class) @RequestBody  DictType dictType){
        dictType = dictTypeService.update(dictType);
        return  Result.success("查询成功",dictType);
    }

    @RequestMapping(value = "/{id}",method = RequestMethod.DELETE)
    public Result deleteById(@PathVariable Long id){
        dictTypeService.deleteById(id);
        return  Result.success("删除成功",null);
    }


    @RequestMapping(value = "/search/{page}/{size}",method = RequestMethod.POST)
    public Result deleteById(@PathVariable Integer page,@PathVariable Integer size,@RequestBody  DictType dictType){
        Page<DictType> pageinfo = dictTypeService.search(page, size, dictType);
        return  Result.success("删除成功",new PageResult<>(pageinfo.getTotalElements(),pageinfo.getContent()));
    }
}
