package com.donglan.BYWeApp.controller;

import com.donglan.BYWeApp.common.PageResult;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.entity.Admin;
import com.donglan.BYWeApp.entity.Order;
import com.donglan.BYWeApp.service.OrderService;
import com.donglan.BYWeApp.validation.OrderValidationGroup;
import org.aspectj.weaver.ast.Or;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * @author shj
 * @date 2021/5/14 10:10 上午
 */
@RestController
@RequestMapping("/order")
@CrossOrigin
public class OrderController {

    @Autowired
    private OrderService orderService;

    @RequestMapping(value = "",method = RequestMethod.POST)
    private Result add(@Validated(value = OrderValidationGroup.Add.class) @RequestBody Order order){
        order = orderService.addNewOrder(order);
        return Result.success("操作成功","");
    }

    @RequestMapping(value="/search/{page}/{size}",method = RequestMethod.POST)
    private Result search(@PathVariable Integer page,@PathVariable Integer size,@RequestBody Order order){
        Page<Order> pageInfo = orderService.search(page,size,order);
        return Result.success("查询成功",new PageResult<>(pageInfo.getTotalElements(),pageInfo.getContent()));

    }
}
