package com.donglan.BYWeApp.controller;

import cn.hutool.core.bean.BeanUtil;
import com.donglan.BYWeApp.common.PageResult;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.entity.ReserveOrder;
import com.donglan.BYWeApp.service.ReserveOrderService;
import com.donglan.BYWeApp.wrapper.DictWrapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author shj
 * @date 2021/6/9 1:50 下午
 */
@RestController
@CrossOrigin
@RequestMapping(value = "/reserveOrder")
public class ReserveOrderController {

    @Autowired
    private ReserveOrderService reserveOrderService;

    @RequestMapping(value = "",method = RequestMethod.POST)
    public Result add(@RequestBody ReserveOrder reserveOrder){
        reserveOrder = reserveOrderService.add(reserveOrder);
        return Result.success("添加成功",reserveOrder);
    }

    @RequestMapping(value = "/search/{page}/{size}",method = RequestMethod.POST)
    public Result search(@PathVariable Integer page,@PathVariable Integer size,@RequestBody ReserveOrder reserveOrder){
        Page<ReserveOrder> pageInfo = reserveOrderService.search(page,size,reserveOrder);
        List<Map<String, Object>> list = pageInfo.getContent().stream().map(BeanUtil::beanToMap).collect(Collectors.toList());
        list = DictWrapper.wrapperList(list, "CAR_TYPE", "typeCode", "carType");
        list.stream().forEach(map->{map.put("id",map.get("id").toString());});
        return Result.success("查询成功",new PageResult<>(pageInfo.getTotalElements(),list,pageInfo.getTotalPages()));
    }

    @RequestMapping(value = "/list/{userId}/{page}/{size}",method = RequestMethod.GET)
    public Result list(@PathVariable Long userId,@PathVariable Integer page,@PathVariable Integer size){
        Page<ReserveOrder> pageInfo = reserveOrderService.findByUserId(userId,page,size);
        return Result.success("查询成功",new PageResult<>(pageInfo.getTotalElements(),pageInfo.getContent(),pageInfo.getTotalPages()));
    }

    @RequestMapping(value = "/waitConsume/{userId}/{page}/{size}",method = RequestMethod.GET)
    public Result waitConsumeList(@PathVariable Long userId,@PathVariable Integer page,@PathVariable Integer size){
        Page<ReserveOrder> pageInfo = reserveOrderService.findUserWaitConsumeList(userId,page,size);
        return Result.success("查询成功",new PageResult<>(pageInfo.getTotalElements(),pageInfo.getContent(),pageInfo.getTotalPages()));
    }
}
