package com.donglan.BYWeApp.controller;

import com.donglan.BYWeApp.common.PageResult;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.entity.Station;
import com.donglan.BYWeApp.service.StationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author shj
 * @date 2021/5/14 4:41 下午
 */
@RestController
@RequestMapping("/station")
public class StationController {

    @Autowired
    private StationService stationService;

    @RequestMapping(value = "/list",method = RequestMethod.GET)
    public Result list(){
        List<Station> list = stationService.list();
        return Result.success(list);
    }

    @RequestMapping(value = "/list/{page}/{size}",method = RequestMethod.GET)
    public Result list(@PathVariable Integer page,@PathVariable Integer size){
        Page<Station> pages = stationService.list(page,size);
        return Result.success(new PageResult<>(pages.getTotalPages(),pages.getContent()));
    }
}
