package com.donglan.BYWeApp.controller;

import cn.binarywang.wx.miniapp.api.WxMaService;
import cn.binarywang.wx.miniapp.bean.WxMaJscode2SessionResult;
import cn.binarywang.wx.miniapp.bean.WxMaUserInfo;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.config.WxMaConfig;
import com.donglan.BYWeApp.entity.User;
import com.donglan.BYWeApp.service.UserService;
import me.chanjar.weixin.common.error.WxErrorException;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;

/**
 * @author shj
 * @date 2021/5/11 2:12 下午
 */
@RestController
@RequestMapping("/wx")
public class WxMaController {

    @Autowired
    private WxMaConfig wxMaConfig;

    @Autowired
    private UserService userService;

    /**
     * 登陆接口
     */
    @GetMapping("/login")
    public Result login(String code) {
        if (StringUtils.isBlank(code)) {
            return Result.fail("empty js code");
        }

        final WxMaService wxService = WxMaConfig.getMaService();

        try {
            WxMaJscode2SessionResult session = wxService.getUserService().getSessionInfo(code);
            String openid = session.getOpenid();
            if(!StrUtil.isBlank(openid)){
                User user = userService.login(session);
                HashMap<String, Object> ret = CollUtil.newHashMap();
                ret.put("userId",user.getId().toString());
                ret.put("isActive",user.getIsActive());
                return Result.success(ret);
            }else {
                return Result.fail("登录失败");
            }

        } catch (WxErrorException e) {
            return Result.fail(e.toString());
        }
    }

//    @GetMapping("/info")
//    public String info( String sessionKey, String signature, String rawData, String encryptedData, String iv) {
//        final WxMaService wxService = WxMaConfig.getMaService();
//
//        // 用户信息校验
//        if (!wxService.getUserService().checkUserInfo(sessionKey, rawData, signature)) {
//            return "user check failed";
//        }
//
//        // 解密用户信息
//        WxMaUserInfo userInfo = wxService.getUserService().getUserInfo(sessionKey, encryptedData, iv);
//
//        return JsonUtils.toJson(userInfo);
//    }
}
