package com.donglan.BYWeApp.dao;


import com.donglan.BYWeApp.entity.User;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Component;

/**
 * @author shj
 * @date 2021/5/11 11:21 上午
 */
public interface UserDao extends JpaRepository<User,Long> {
    public User findUserByWxOpenId(String openId);
    public User findUserByWxUnionId(String unionId);

    @Query(value = "select * from user WHERE referrer_id =?1 AND EXISTS(select 1 from vorder WHERE user_id = user.id )",
            countQuery="select count(1)  from user WHERE referrer_id =?1 AND EXISTS(select 1 from vorder WHERE user_id = user.id )",nativeQuery = true)
    public Page<User> findHasOrderUserByReferrerId(Long referrerId, Pageable pageable);

    @Query(value = "select  *  from user WHERE referrer_id =?1 AND NOT EXISTS(select 1 from vorder WHERE user_id = user.id )",
            countQuery = "select count(1)  from user WHERE referrer_id =?1 AND NOT EXISTS(select 1 from vorder WHERE user_id = user.id )",nativeQuery = true)
    public Page<User> findNoOrderUserByReferrerId(Long referrerId, Pageable pageable);
}
