package com.donglan.BYWeApp.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.Where;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.Id;
import java.util.Date;

/**
 * @author shj
 * @date 2021/6/10 2:07 下午
 */
@Data
@Entity
@EntityListeners(AuditingEntityListener.class)
@DynamicInsert
public class Activity {
    @Id
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    private String title;

    private String type;

    @Column(columnDefinition = "longtext" )
    private String detail;

    private String address;

    private Date startTime;

    private Date endTime;

    private Integer integral;

    private String remark;

    @Column(columnDefinition = "tinyint default 0")
    private Boolean state;

    @Column(columnDefinition = "tinyint default 0")
    private Boolean deleted;

    private Long stationId;

    @CreatedDate
    private Date createTime;

    @CreatedBy
    private Long createUser;

    @LastModifiedDate
    private Date updateTime;

    @LastModifiedBy
    private Long updateUser;
}
