package com.donglan.BYWeApp.entity;

import com.donglan.BYWeApp.validation.AdminValidationGroup;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.validator.constraints.Length;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.*;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @author shj
 * @date 2021/5/31 1:06 下午
 */
@Data
@Entity
@EntityListeners(AuditingEntityListener.class)
@DynamicInsert
public class Admin {
    @Id
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @NotBlank(message = "用户名不能为空",groups = {AdminValidationGroup.Add.class,AdminValidationGroup.Login.class})
    private String username;

    @NotBlank(message = "密码不能为空字符串",groups = {AdminValidationGroup.Login.class})
    private String password;

    private String name;

    private Long stationId;

    @Column(columnDefinition = "tinyint default 0")
    private Boolean state;

    @Column(columnDefinition = "tinyint default 0")
    private Boolean deleted;

    @ManyToOne
    @JoinColumn(name = "stationId",insertable = false,updatable = false)
    private Station station;

    @CreatedDate
    private Date createTime;

    @CreatedBy
    private Long createUser;

    @LastModifiedDate
    private Date updateTime;

    @LastModifiedBy
    private Long updateUser;
}
