package com.donglan.BYWeApp.entity;

import com.donglan.BYWeApp.validation.DictTypeValidationGroup;
import com.donglan.BYWeApp.validation.DictValidationGroup;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @author shj
 * @date 2021/6/8 4:09 下午
 */
@Data
@Entity(name = "dictionary")
@EntityListeners(AuditingEntityListener.class)
@DynamicInsert
public class Dict {
    @Id
    @JsonSerialize(using = ToStringSerializer.class)
    @NotNull(message = "id不能为空",groups = {DictValidationGroup.Update.class})
    private Long id;

    @NotBlank(message = "字典类型名称不能为空",groups = {DictValidationGroup.Add.class,DictValidationGroup.Update.class})
    private String type;

    @NotBlank(message = "编码不能为空",groups = {DictValidationGroup.Add.class,DictValidationGroup.Update.class})
    private String code;

    @NotBlank(message = "标签不能为空",groups = {DictValidationGroup.Add.class,DictValidationGroup.Update.class})
    private String label;

    @CreatedDate
    private Date createTime;

    @CreatedBy
    private Long createUser;

    @LastModifiedDate
    private Date updateTime;

    @LastModifiedBy
    private Long updateUser;
}
