package com.donglan.BYWeApp.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.*;
import java.util.Date;

/**
 * @author shj
 * @date 2021/5/14 9:56 上午
 */
@Data
@Entity
@EntityListeners(AuditingEntityListener.class)
@DynamicInsert
public class IntegralDetails {

    @Id
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    private Long userId;

    @ManyToOne
    @JoinColumn(name = "userId",insertable = false,updatable = false)
    private User user;

    private Integer integral;

    private String reason;

    private Long orderId;

    private Long activityId;

    @OneToOne
    @JoinColumn(name = "orderId",insertable = false,updatable = false)
    private Order order;

    @CreatedDate
    private Date createTime;

    @CreatedBy
    private Long createUser;

    @LastModifiedDate
    private Date updateTime;

    @LastModifiedBy
    private Long updateUser;
}
