package com.donglan.BYWeApp.entity;

import com.donglan.BYWeApp.validation.AdminValidationGroup;
import com.donglan.BYWeApp.validation.OrderValidationGroup;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.*;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @author shj
 * @date 2021/5/14 10:04 上午
 */
@Entity(name = "vorder")
@Data
@EntityListeners(AuditingEntityListener.class)
@DynamicInsert
public class Order {
    @Id
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @NotNull(message = "用户ID不能为空",groups = {OrderValidationGroup.Add.class})
    private Long userId;

    @ManyToOne
    @JoinColumn(name = "userId",insertable = false,updatable = false)
    private User user;
    
    @NotBlank(message = "车牌号不能为空",groups = {OrderValidationGroup.Add.class})
    private String carNumber;

    private Long reserveId;

    private Long stationId;

    @ManyToOne
    @JoinColumn(name = "stationId",insertable = false,updatable = false)
    private Station station;

    @CreatedDate
    private Date createTime;

    @CreatedBy
    private Long createUser;

    @LastModifiedDate
    private Date updateTime;

    @LastModifiedBy
    private Long updateUser;
}
