package com.donglan.BYWeApp.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.omg.CORBA.PRIVATE_MEMBER;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.*;
import java.util.Date;

/**
 * @author shj
 * @date 2021/6/8 3:55 下午
 */
@Data
@Entity
@EntityListeners(AuditingEntityListener.class)
@DynamicInsert
public class ReserveOrder {
    @Id
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    private String name;

    private String phone;

    private String carPlate;

    private Date reserveDate;

    private String typeCode;

    private Long userId;

    @Column(columnDefinition = "tinyint default 1")
    private Integer state;

    @CreatedDate
    private Date createTime;

    @CreatedBy
    private Long createUser;

    @LastModifiedDate
    private Date updateTime;

    @LastModifiedBy
    private Long updateUser;
}
