package com.donglan.BYWeApp.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.StringSerializer;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.Id;
import java.util.Date;

/**
 * @author shj
 * @date 2021/5/11 11:22 上午
 */
@Data
@Entity
@EntityListeners(AuditingEntityListener.class)
@DynamicInsert
public class User {
    @Id
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    private String wxName;

    private String wxOpenId;

    private String wxUnionId;

    private String sessionKey;

    private String wxAvatar;

    private String wxPhone;

    private String wxAddress;

    @JsonIgnore
    private String shareQrCodePath;

    @JsonIgnore
    private String payQrCodePath;

    @JsonIgnore
    private Long referrerId;

    @Column(columnDefinition = "int default 0")
    private Integer integral;

    @Column(columnDefinition = "tinyint default 0")
    private Boolean isActive;

    @CreatedDate
    private Date createTime;

    @CreatedBy
    private Long createUser;

    @LastModifiedDate
    private Date updateTime;

    @LastModifiedBy
    private Long updateUser;

}
