package com.donglan.BYWeApp.exceptions.handler;

import com.donglan.BYWeApp.common.Result;
import com.donglan.BYWeApp.exceptions.BaseException;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * @author shj
 * @date 2021/5/11 4:38 下午
 */

@ControllerAdvice
@ResponseBody
public class GlobalExceptionHandler {

    @ExceptionHandler(value = MethodArgumentNotValidException.class)
    public Result methodArgsNotValidExceptionHandler(MethodArgumentNotValidException e){
        return Result.fail(200005,e.getBindingResult().getFieldError().getDefaultMessage(),"");
    }

    @ExceptionHandler(value = BaseException.class)
    public Result UserNameHasExistExceptionHandler(BaseException e){
        return Result.fail(e.getCode(),e.getMessage(),"");
    }


}

