package com.donglan.BYWeApp.service;

import cn.hutool.core.lang.Snowflake;
import com.donglan.BYWeApp.dao.IntegralDetailsDao;
import com.donglan.BYWeApp.entity.IntegralDetails;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author shj
 * @date 2021/5/14 10:12 上午
 */
@Service
@Transactional
public class IntegralDetailsService {

    @Autowired
    private IntegralDetailsDao integralDetailsDao;

    @Autowired
    private Snowflake snowflake;

    public IntegralDetails add(IntegralDetails integralDetails) {
        integralDetails.setId(snowflake.nextId());
        return integralDetailsDao.save(integralDetails);
    }

    public Page<IntegralDetails> searchByUserId(Integer page, Integer size, IntegralDetails integralDetails) {
        Sort sort = new Sort(Sort.Direction.DESC,"createTime");
        Pageable pageable =   PageRequest.of(page-1,size,sort);
        return integralDetailsDao.findAllByUserId(integralDetails.getUserId(),pageable);
    }
}
