package com.donglan.BYWeApp.service;

import cn.hutool.core.lang.Snowflake;
import com.donglan.BYWeApp.dao.OrderDao;
import com.donglan.BYWeApp.dao.ReserveOrderDao;
import com.donglan.BYWeApp.entity.*;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;

/**
 * @author shj
 * @date 2021/5/14 10:12 上午
 */
@Service
@Transactional
public class OrderService {

    @Autowired
    private Snowflake snowflake;

    @Autowired
    private OrderDao orderDao;

    @Autowired
    private UserService userService;

    @Autowired
    private HttpServletRequest request;

    @Autowired
    private AdminService adminService;

    @Autowired
    private ActivityService activityService;

    @Autowired
    private ReserveOrderService reserveOrderService;

    public Order addNewOrder(Order order) {
        order.setId(snowflake.nextId());
        Admin admin = adminService.findById((Long) request.getSession().getAttribute("adminId"));
        order.setStationId(admin.getStationId());
        order.setCreateUser(admin.getId());
        activityService.runShareActivity(order);
        order = orderDao.save(order);
        if(order.getReserveId()!=null){
            ReserveOrder reserveOrder = reserveOrderService.findById(order.getId());
            reserveOrder.setState(0);
            reserveOrderService.update(reserveOrder);
        }
        return order;
    }

    public Page<Order> search(Integer page, Integer size, Order order) {
        Pageable pageable = PageRequest.of(page-1,size);
        return orderDao.findAll(pageable);
    }

    public Integer countByUserId(Long userId){
        return orderDao.countAllByUserId(userId);
    }

    public Order findFirstByUserId(Long userId){
        return orderDao.findFirstByUserId(userId);
    }
}
