package com.donglan.BYWeApp.service;

import cn.binarywang.wx.miniapp.bean.WxMaCodeLineColor;
import cn.binarywang.wx.miniapp.bean.WxMaUserInfo;
import com.donglan.BYWeApp.config.WxMaConfig;
import com.donglan.BYWeApp.exceptions.BaseException;
import me.chanjar.weixin.common.error.WxErrorException;
import org.springframework.stereotype.Service;

import java.io.File;

/**
 * @author shj
 * @date 2021/5/11 3:19 下午
 */
@Service
public class WxMaService {

    public WxMaUserInfo getUserInfo(String sessionKey, String signature, String rawData, String encryptedData, String iv){
        final cn.binarywang.wx.miniapp.api.WxMaService wxService = WxMaConfig.getMaService();

        // 用户信息校验
        if (!wxService.getUserService().checkUserInfo(sessionKey, rawData, signature)) {
//            return "user check failed";
            throw new BaseException(210001,"用户校验失败");
        }

        // 解密用户信息
        WxMaUserInfo userInfo = wxService.getUserService().getUserInfo(sessionKey, encryptedData, iv);
        return userInfo;
    }

    public File generateQrCode(String scene, String page) throws WxErrorException {
        final cn.binarywang.wx.miniapp.api.WxMaService wxService = WxMaConfig.getMaService();
        WxMaCodeLineColor wxMaCodeLineColor = new WxMaCodeLineColor("255","255","255");
        return wxService.getQrcodeService().createWxaCodeUnlimit(scene,page,430,false, wxMaCodeLineColor, false);
    }
}
