package com.donglan.BYWeApp.wrapper;

import com.donglan.BYWeApp.entity.Dict;
import com.donglan.BYWeApp.service.DictService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author shj
 * @date 2021/6/21 10:12 上午
 */
@Component
public class DictWrapper {

    private static DictService dictService;

    public static Map<String,Object> wrapper(Map<String,Object> obj, String dictType, String valueField, String destProp){
        if(obj== null || obj.keySet().size()==0)
            return obj;
        Dict dict = dictService.findByTypeAndCode(dictType, obj.get(valueField).toString());
        obj.put(destProp,dict.getLabel());
        return obj;
    }

    public static List<Map<String,Object>> wrapperList(List<Map<String,Object>> objs,String dictType,String valueField,String destProp){
        if(objs.size()==0){
            return objs;
        }
        List<Dict> dicts = dictService.findByType(dictType);
        for(int i=0;i<objs.size();i++){
            Map<String,Object> obj = objs.get(i);

            dicts.stream().forEach(dict -> {
                if(dict.getCode().equals(obj.get(valueField)))
                    obj.put(destProp,dict.getLabel());
            });
        }
        return objs;
    }

    @Autowired
    public void setDictService(DictService dictService) {
        DictWrapper.dictService = dictService;
    }
}
